package CH.ifa.draw.application;

import java.io.*;
import java.net.*;
import java.util.*;
import de.renew.util.StringUtil;
import CH.ifa.draw.util.GUIProperties;

public class DrawingLoadClient {

  public static void loadDrawings(String[] fileName) {
    int serverPort=GUIProperties.loadServerPort();
    if (serverPort == -1) {
      System.err.println("No port specified, please set property de.renew.loadServerPort.");
      System.exit(1);
    } 
    
    // connect to the server:
    try {
      Socket s=new Socket("127.0.0.1",serverPort);
      PrintWriter toSocket=new PrintWriter(s.getOutputStream());
      for (int i=0; i<fileName.length; ++i) {
	toSocket.println(StringUtil.makeCanonical(fileName[i]));
      }
      toSocket.close();
      s.close();
    } catch (UnknownHostException e1) {
      System.out.println("localhost (127.0.0.1) not found. Please set up TCP/IP correctly.");
    } catch (IOException e2) {
      System.out.println("Probably the DrawingLoadServer is not running on port "+serverPort+"? Exception:\n"+e2);
    }
  }

  public static void main(String[] argc) {
    loadDrawings(argc);
  }

}
