/*
 * @(#)UngroupCommand.java 5.1
 *
 */

package CH.ifa.draw.figures;

import java.awt.*;
import java.util.*;
import CH.ifa.draw.framework.*;


/**
 * Command to ungroup the selected figures.
 * @see GroupCommand
 */
public  class UngroupCommand extends UndoableCommand {

    protected DrawingEditor fEditor;

   /**
    * Constructs a group command.
    * @param name the command name
    * @param view the target view
    */
    public UngroupCommand(String name, DrawingEditor editor) {
        super(name, editor);
        fEditor = editor;
    }

    public boolean executeUndoable() {
        DrawingView view = fEditor.view();
        FigureEnumeration selection = view.selectionElements();
        view.clearSelection();

        Vector parts = new Vector();
        while (selection.hasMoreElements()) {
            Figure selected = selection.nextFigure();
            Figure group = view.drawing().orphan(selected);
            FigureEnumeration k = group.decompose();
            while (k.hasMoreElements())
                parts.addElement(k.nextFigure());
        }
	view.addAll(parts);
	view.addToSelectionAll(parts);
        view.checkDamage();
	return true;
    }

    public boolean isExecutable() {
        return fEditor.view().selectionCount() > 0;
    }

}
