/*
 * @(#)BringToFrontCommand.java 5.1
 *
 */

package CH.ifa.draw.standard;

import java.util.*;
import CH.ifa.draw.framework.*;

/**
 * BringToFrontCommand brings the selected figures in the front of
 * the other figures.
 *
 * @see SendToBackCommand
 */
public class BringToFrontCommand
       extends UndoableCommand {

   protected DrawingEditor fEditor;

   /**
    * Constructs a bring to front command.
    * @param name the command name
    * @param view the target view
    */
    public BringToFrontCommand(String name, DrawingEditor editor) {
        super(name, editor);
        fEditor = editor;
    }

    public boolean executeUndoable() {
       DrawingView view = fEditor.view();
       FigureEnumeration k = new FigureEnumerator(view.selectionZOrdered());
       while (k.hasMoreElements()) {
            view.drawing().bringToFront(k.nextFigure());
       }
       view.checkDamage();
       return true;
    }

    public boolean isExecutable() {
        return fEditor.view().selectionCount() > 0;
    }
}


