/*
 * @(#)ChangeAttributeCommand.java 5.1
 *
 */

package CH.ifa.draw.standard;

import java.awt.Color;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.util.*;

/**
 * Command to change a named figure attribute.
 */
public  class ChangeAttributeCommand
        extends UndoableCommand {

    protected DrawingEditor fEditor;

    private String      fAttribute;
    private Object      fValue;

   /**
    * Constructs a change attribute command.
    * @param name the command name
    * @param attributeName the name of the attribute to be changed
    * @param value the new attribute value
    * @param view the target view
    */
    public ChangeAttributeCommand(String name, String attributeName,
                           Object value, DrawingEditor editor) {
        super(name, editor);
        fAttribute = attributeName;
        fValue = value;
        fEditor = editor;
    }

    public boolean executeUndoable() {
        DrawingView view = fEditor.view();
        FigureEnumeration k = view.selectionElements();
        while (k.hasMoreElements()) {
            Figure f = k.nextFigure();
            f.setAttribute(fAttribute, fValue);
        }
        view.checkDamage();
	return true;
    }

    public boolean isExecutable() {
        return fEditor.view().selectionCount() > 0;
    }

}


