/*
 * @(#)Drawing.java 5.1
 *
 */

package CH.ifa.draw.standard;

import CH.ifa.draw.framework.*;
import CH.ifa.draw.util.*;
import java.awt.*;
import java.util.*;
import java.io.*;

public class NullDrawing extends FigureChangeAdapter
                         implements Drawing, Storable, Serializable
{
  public static NullDrawing INSTANCE=new NullDrawing();
  // I cannot make the constructor private, because I must
  // be storable.
  public NullDrawing() {}

  public String getName() { return ""; }
  public void setName(String name) {}
  public String getFilename() { return ""; }
  public void setFilename(String filename) {}
  // Always claim to backuped, so that no backups are ever made.
  public boolean getBackupStatus() { return true; }
  public void setBackupStatus(boolean status) {}

  public void release() {}
  public Rectangle displayBox() { return new Rectangle(); }
  public FigureEnumeration figures() { 
    return new FigureEnumerator(new Vector());
  }
  public FigureEnumeration figuresReverse() {
    return figures();
  }
  public Figure findFigure(int x, int y) {
    return null;
  }
  public Figure findFigure(Rectangle r) {
    return null;
  }
  public Figure findFigureWithout(int x, int y, Figure without) {
    return null;
  }
  public Figure findFigure(Rectangle r, Figure without) {
    return null;
  }
  public Figure findFigureInside(int x, int y) {
    return null;
  }
  public Figure findFigureInsideWithout(int x, int y, Figure without) {
    return null;
  }
  public void addDrawingChangeListener(DrawingChangeListener listener) {}
  public void removeDrawingChangeListener(DrawingChangeListener listener) {}
  public Enumeration drawingChangeListeners() {
    return new Vector().elements();
  }
  public void checkDamage() {}

  public Figure add(Figure figure) {
    return figure;
  }
  public void addAll(Vector newFigures) {}
  public Figure remove(Figure figure) {
    return figure;
  }
  public Figure orphan(Figure figure) {
    return figure;
  }
  public void orphanAll(Vector newFigures) {}
  public void removeAll(Vector figures) {}
  public void removeAll() {}
  public void replace(Figure figure, Figure replacement) {}
  public void sendToBack(Figure figure) {}
  public void bringToFront(Figure figure) {}
  public void draw(Graphics g) {}
  public void lock() {}
  public void unlock() {}
  public void write(StorableOutput so) {}
  public void read(StorableInput si) {}
  public boolean isModified() { return false; }
  public void clearModified() {}
  public Rectangle getBounds() { return new Rectangle(0,0,0,0); }
  public Dimension defaultSize() { return new Dimension(0,0); }
  public String getWindowCategory() { return "<BUG> Null drawings"; }
}
