package CH.ifa.draw.standard;

import java.awt.*;
import java.awt.event.*;

/**
 *   generic Yes/No/Cancel Dialog
 *
 *  06.12.2000 MK/HR
 *
 */

public class YesNoCancelDialog {

    private Dialog dialog;

    protected Button yesButton, noButton, cancelButton;
    protected MultiLineLabel label; 
    protected int result;

    protected Frame parent;
    protected String title,message;

    public static final int YES = 1, NO = 2, CANCEL = 0;


    public YesNoCancelDialog(Frame parent, String title, String message) {
	this.parent = parent;
	this.title = title;
	this.message = message;    
    }


    public int execute() {	
	dialog = new Dialog(parent,title,true);

	final int[] result = new int[1];
	result[0] = CANCEL; //default
	
	dialog.setLayout(new BorderLayout(15,15));
	
	label=new MultiLineLabel(message,20,20);
	
	dialog.add("Center", label);
	
	yesButton=new Button("Yes");
	yesButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e){
		    result[0] = YES;
		    dialog.dispose();
		}
	    });

	noButton=new Button("No");
	noButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e){
		    result[0] = NO;
		    dialog.dispose();
		}
	    });

	cancelButton=new Button("Cancel");
	cancelButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e){
		    result[0] = CANCEL;
		    dialog.dispose();
		}
	    });

	Panel p=new Panel();	
	p.setLayout(new FlowLayout(FlowLayout.CENTER,15,15));
	p.add(yesButton);
	p.add(noButton);
	p.add(cancelButton);
	dialog.add("South",p);
	
	dialog.pack();	
	dialog.show();

	return(result[0]);

    }

}
 
