/*
 * @(#)Animator.java 5.1
 *
 */

package CH.ifa.draw.util;

import java.awt.*;
import java.util.*;
import CH.ifa.draw.framework.*;


public  class Animator extends Thread {

    private DrawingView     fView;
    private Animatable      fAnimatable;

    private boolean             fIsRunning;
    private static final int    MAX_DELAY = 1000 / 16;
    private static final int    MIN_DELAY = MAX_DELAY / 4;

    public Animator(Animatable animatable, DrawingView view) {
        super("Animator");
	setPriority(MIN_PRIORITY);
        fView = view;
        fAnimatable = animatable;
    }

    public void start() {
        super.start();
        fIsRunning = true;
	fAnimatable.animationStart();
    }

    public void end() {
	fAnimatable.animationStop();
        fIsRunning = false;
    }

    public void run() {
        while (fIsRunning) {
            long tm = System.currentTimeMillis();
            fView.freezeView();
            fAnimatable.animationStep();
            fView.checkDamage();
            fView.unfreezeView();

            // Delay for a while
            try {
                tm += MAX_DELAY;
                Thread.sleep(Math.max(MIN_DELAY, 
				      tm - System.currentTimeMillis()));
            } catch (InterruptedException e) {
                break;
            }
        }
    }
}

