package CH.ifa.draw.util;

import java.awt.*;

public class ExtendedFont extends Font {

  public static final int UNDERLINED=
      Math.max(Math.max(Font.PLAIN,Font.BOLD),Font.ITALIC)*2;

    private int underlined; // either 0 or UNDERLINED

  public ExtendedFont(String name, int style, int size) {
     super(name, style & ~UNDERLINED, size);
     underlined = style & UNDERLINED;
  }

  public int getStyle() {
    return super.getStyle() | underlined;
  }

  public boolean isPlain() {
    return super.isPlain() && underlined==0;
  }

  public boolean isUnderlined() {
    return underlined!=0;
  }

  public boolean equals(Object that) {
    if (super.equals(that)) {
      if (that instanceof ExtendedFont) {
	return ((ExtendedFont)that).underlined==underlined;
      }
      return underlined==0;
    }
    return false;
  }

}
