package CH.ifa.draw.util;

import java.awt.*;
import java.awt.event.*;

public class Palette extends Panel
                     implements KeyListener {

    private Frame menuFrame;
    private Dialog ownFrame=null;
    private Container toolPanel=null;
    private boolean vertical=false;

    public Palette(final Frame menuFrame, String title) {
	this.menuFrame=menuFrame;
	setName(title);
	setBackground(Color.lightGray);
        setLayout(new PaletteLayout(2,new Point(2,2),false));
	addMouseListener(new MouseAdapter() {
	    public void mousePressed(MouseEvent event) {
		if (toolPanel==null) {
		  toggleWindow();
		} else {
		  toggleVertical();
		}
	    }
	});
    }

    public Component add(Component c) {
	super.add(c);
	c.addKeyListener(this);
	return c;
    }

    private void toggleWindow() {
	PaletteLayout layout=(PaletteLayout)getLayout();
	if (toolPanel==null) {
	  if (ownFrame==null) {
	    ownFrame=new Dialog(menuFrame,getName(),false);
	    ownFrame.setResizable(false);
	    ownFrame.addWindowListener(
	      new WindowAdapter() {
		public void windowClosing(WindowEvent event) {
		  toggleWindow();
		}
		public void windowActivated(WindowEvent event) {
		  ownFrame.requestFocus(); // !!!
		}
	      }
            );
	  }
	  toolPanel=getParent();
	  ownFrame.add(this);
	  layout.setVertical(vertical);
	  menuFrame.pack();
	  ownFrame.setVisible(true);
	  ownFrame.pack();
	} else {
	  ownFrame.setVisible(false);
	  layout.setVertical(false);
	  toolPanel.add(this);
	  menuFrame.pack();
	  toolPanel=null;
	}
    }

    private void toggleVertical() {
	if (ownFrame==null || toolPanel==null)  // should not be!
	    return;
	PaletteLayout layout=(PaletteLayout)getLayout();
	vertical=!vertical;
	layout.setVertical(vertical);
//  	if (vertical)
//  	    ownFrame.setTitle("");
//  	else
//  	    ownFrame.setTitle(getName());
	doLayout();
	ownFrame.pack();
    }

    /**
     * Handles key down events by dispatching them to the menu frame.
     */
    public void keyPressed(KeyEvent e) {
      menuFrame.dispatchEvent(e);
    }

    public void keyTyped(KeyEvent e) { }
    public void keyReleased(KeyEvent e) { }
}
