package de.renew.formalism.fs;

import de.renew.simulator.*;
import de.renew.unify.*;
import de.uni_hamburg.fs.*;
import java.util.Enumeration;

public class FSInhibitorArcBinder extends InhibitorArcBinder {
  
  protected FSInhibitorArcBinder(Variable variable,
		                 PlaceInstance placeInstance)
    {
	super(variable,placeInstance);
    }

  protected boolean possible(TokenReserver reserver, Object token) {
      if (token instanceof FeatureStructure) {
	  FeatureStructure fs=(FeatureStructure)token;
	  Enumeration tokens = getPlaceInstance().getDistinctTestableTokens();
	  while (tokens.hasMoreElements()) {
	      Object tok=tokens.nextElement();
	      if (tok instanceof FeatureStructure &&
		  fs.canUnify((FeatureStructure)tok))
		  return false;
	  }
	  return true;
      }
      return super.possible(reserver,token);
  }

}
