package de.renew.formalism.fs;

import java.util.*;
import de.renew.simulator.*;
import de.renew.unify.Impossible;

public class ObjectNetInstance extends NetInstanceImpl {
  protected ObjectNetInstance(String netName, Hashtable marking)
    throws Impossible, NetNotFoundException
  {
    this(Net.forName(netName),marking);
  }

  protected ObjectNetInstance(Net net, Hashtable marking)
    throws Impossible
  {
    super(net);
    
    // Build hashtable of place names.
    Hashtable nameToPlace=new Hashtable();
    Enumeration enum=net.places();
    while (enum.hasMoreElements()) {
      Place place=(Place)enum.nextElement();
      nameToPlace.put(place.toString(),place);
    }

    // Transfer tokens.
    enum=marking.keys();
    while (enum.hasMoreElements()) {
      String name=(String)enum.nextElement();
      PlaceInstance instance=getInstance((Place)nameToPlace.get(name));

      Enumeration tokens=((Vector)marking.get(name)).elements();
      while (tokens.hasMoreElements()) {
	// This used to be done silently. As there should be no 
	// listeners yet, it can be done openly just as well.
	instance.insertToken(tokens.nextElement(),
			     SearchQueue.getTime());
      }
    }
  }
}
