package de.renew.formalism.fsnet;

import de.renew.unify.Impossible;
import de.renew.function.Function;
import de.renew.unify.Tuple;
import de.uni_hamburg.fs.*;

public class FSUnifyAtFunction implements Function {
  Path path;

  public FSUnifyAtFunction(Path path) {
    this.path=path;
  }

  public Object function(Object param) throws Impossible {
    //System.out.println("FSUnifyAtFunction of path "+path+" called with "+param);
    Tuple tuple=(Tuple)param;
    if (tuple.getArity()!=2) {
      throw new Impossible();
    }
    try {
      FeatureStructure fs1=(FeatureStructure)tuple.getComponent(0);
      FeatureStructure fs2=(FeatureStructure)tuple.getComponent(1);
      //System.out.println("Trying to unify "+fs1+" and "+fs2+" at "+path+"...");
      return fs1.unify(fs2,path);
    }
    catch (Exception e) {
	//System.out.println("Cannot unify "+tuple.getComponent(0)
	//		   +" with "+tuple.getComponent(1)+" at "+path);
      throw new Impossible("Cannot unify "+tuple.getComponent(0)
			   +" with "+tuple.getComponent(1)+" at "+path);
    }
  }
}
