package de.renew.function;

import de.renew.unify.*;
import de.renew.util.Value;
import java.lang.reflect.*;

public class DynamicFieldFunction implements Function {
	String field;

	public DynamicFieldFunction(String field) {
		this.field=field;
	}

	public Object function(Object param) throws Impossible {
		try {
			if (param.getClass().isArray()) {
				if (field.equals("length")) {
					return new Value(new Integer(Array.getLength(param)));
				} else {
					throw new Impossible();
				}
			}

			Field theField = param.getClass().getField((String)field);

			return Value.possiblyWrap(theField.get(param),
				theField.getType().isPrimitive());
		} catch (Exception e) {
			if (e instanceof InvocationTargetException) {
				throw new Impossible("InvocationTargetException occured during method call: "
					+ ((InvocationTargetException) e).getTargetException());
			} else {
				throw new Impossible("Exception occured during method call: " + e);
			}
		}
	}

	public String toString() {
		return "DynFieldFunc("+field+")";
	}
}

