/*
 * @(#)ArcConnectionHandle.java 5.1
 *
 */

package de.renew.gui;

import java.awt.*;
import java.util.Vector;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.util.Geom;

/**
 * A handle to connect Places to Transitions and vice versa.
 *
 * @see ConnectionFigure
 */

public  class ArcConnectionHandle extends ConnectionHandle {

    /**
     * Constructs a handle for the given owner
     */
    public ArcConnectionHandle(Figure owner) {
        super(owner, RelativeLocator.center(), ArcConnection.NormalArc);
    }

  protected PlaceFigure createPlaceFigure() {
    PlaceFigure figure=new PlaceFigure();
    Dimension d=PlaceFigure.defaultDimension();
    figure.displayBox(new Point(0,0),new Point(d.width,d.height));

    return figure;
  }

  protected TransitionFigure createTransitionFigure() {
    TransitionFigure figure=new TransitionFigure();
    Dimension d=TransitionFigure.defaultDimension();
    figure.displayBox(new Point(0,0),new Point(d.width,d.height));
    return figure;
  }

  protected void addInscriptions(Figure figure, DrawingView view) {
    // Overridden in subclasses.
  }

    /**
     * Connects the figures if the mouse is released over another
     * Transition/Place figure;
     * otherwise, the respective figure is created!
     */
    public void invokeEnd(int x, int y, int anchorX, int anchorY, DrawingView view) {
        Connector target = findConnectionTarget(x, y, view.drawing());
        if (target == null) {
           Figure owner = owner();
           if (owner.findFigureInside(x,y)==null) {
               Figure endFigure;
               if (owner instanceof PlaceFigure) {
                  //System.out.println("Creating Transition!");
		  endFigure=createTransitionFigure();
               } else {
                  //System.out.println("Creating Place!");
                  endFigure=createPlaceFigure();
               }
	       Rectangle rect=endFigure.displayBox();
               int w2=rect.width/2, h2=rect.height/2;
               endFigure.displayBox(new Point(x-w2,y-h2),
		 new Point(x-w2+rect.width,y-h2+rect.height));

	       view.add(endFigure);

	       addInscriptions(endFigure,view);
           }
        }
        super.invokeEnd(x,y,anchorX,anchorY,view);
    }

}
