/*
 * @(#)CPNSelectionTool.java 5.1
 *
 */

package de.renew.gui;

import java.awt.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.ColorMap;

class CPNSelectionTool extends SelectionTool {

  private RenewMode mode;

  public CPNSelectionTool(CPNApplication application, RenewMode mode) {
    super(application);
    this.mode=mode;
  }

  protected boolean alternateInspectFigure(Figure f) {
     if (f instanceof InscribableFigure) {
        editor().prepareUndoSnapshot();
        InscribableFigure inf=(InscribableFigure)f;
	CPNTextFigure child=mode.newInscriptionFigure(inf);
	child.setParent(inf);
	Point p=view().lastClick();
	child.displayBox(p,new Point(p.x+10,p.y+10));
	child.setText(mode.getDefaultInscription(inf));
	child.setAttribute("TextType",new Integer(CPNTextFigure.INSCRIPTION));
	if (inf instanceof LineConnection) {
	    child.setAttribute("FillColor",ColorMap.BACKGROUND);
	}
	drawing().add(child);
	view().clearSelection();
	view().addToSelection(child);
	editor().commitUndoSnapshot();
	return true;
     } else {
        return super.alternateInspectFigure(f);
     }
  }

}
