package de.renew.gui;

import CH.ifa.draw.util.Command;
import CH.ifa.draw.framework.DrawingEditor;
import CH.ifa.draw.util.*;
import de.renew.remote.*;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.util.Vector;


/**
 * Connects to another simulation server.
 *
 * @author Thomas Jacob
 */
public class ConnectCommand extends Command
{
	private CPNApplication editor;

	public ConnectCommand(String name, CPNApplication editor)
	{
		super(name);
		this.editor = editor;
	}

	public boolean isExecutable()
	{
		return true;
	}

	public void execute()
	{
		try
		{
			ConnectDialog dialog = new ConnectDialog(editor.menuFrame());
			if (!dialog.hasCancelled())
			{
				Server server = ServerImpl.getInstance(dialog.getHost(), dialog.getServer());
				NetInstanceSelectionFrame.open(editor, server, dialog.getHost(), dialog.getServer());
			}
		}
		catch (NotBoundException e)
		{
			MessageDialog.invokeDialog(editor.menuFrame(), "Cannot connect to server",
				new String[] {"Cannot connect to server:", "The server could not be found."},
				MessageDialog.LEFT, new String[] {"  OK  "}, 0);
		}
		catch (Exception e)
		{
			e.printStackTrace(System.err);
			MessageDialog.invokeDialog(editor.menuFrame(), "Cannot connect to server",
				new String[] {"Cannot connect to server:", "There was an exception.",
				"See output window for details.", e.toString()},
				MessageDialog.LEFT, new String[] {"  OK  "}, 0);
		}
	}
}
