package de.renew.gui;

import CH.ifa.draw.framework.Tool;
import CH.ifa.draw.standard.ConnectionTool;
import de.renew.shadow.ShadowCompiler;
import de.renew.shadow.NullCompiler;
import de.renew.formalism.java.*;
import java.awt.*;

public class DrawMode extends SequentialJavaMode {
  public ShadowCompiler getCompiler() {
    return new NullCompiler();
  }

  public CPNSimulation getSimulation() {
    
    if (fSimulation==null)
      fSimulation=new CPNSimulation(getCompiler(),true,getDrawingLoader());
    return fSimulation;
  }

  public void createAdditionalTools(CPNApplication editor, Panel palette) {
    Tool tool = new ConnectionTool(editor, InhibitorConnection.InhibitorArc);
    palette.add(editor.createToolButton(CPNApplication.CPNIMAGES+"INHIB",
      "InhibitorArc Tool", tool));

    tool = new ConnectionTool(editor, DoubleArcConnection.DoubleArc);
    palette.add(editor.createToolButton(CPNApplication.CPNIMAGES+"DARC",
      "DoubleArc Tool", tool));

    palette.add(new java.awt.Canvas());
    palette.add(new java.awt.Canvas());
  }
}
