package de.renew.gui;

import java.awt.*;
import java.util.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;

public class HorizontalCompositeFigure extends SimpleCompositeFigure {

	 /**
		* Pass-through-constructor for subclasses. Does nothing.
		**/
	 protected HorizontalCompositeFigure() {}

	 /**
		* Creates a new composite figure with one contained
		* figure. The composite figure is layouted immediately after
		* creation. Additional figures can be added at later times.
		**/
	 public HorizontalCompositeFigure(Figure fig) {
			add(fig);
			layout();
	 }

   protected void layout() {
      Dimension extent = calcExtent();
      fDisplayBox.width = extent.width;
      fDisplayBox.height = extent.height;

      Enumeration figenum = figures();
      Point location = fDisplayBox.getLocation();
      while (figenum.hasMoreElements()) {
          Figure figure = (Figure)figenum.nextElement();
          Dimension figureDim = figure.size();
          location.y = fDisplayBox.y+Math.max(0,(fDisplayBox.height-figureDim.height)/2);
          Point corner = new Point(location.x+figureDim.width,
		                                    location.y+figureDim.height);
          figure.basicDisplayBox(location, corner);
          location.x += figureDim.width;
      }
      super.layout();
   }

   protected boolean needsLayout() {
      return !size().equals(calcExtent());
   }

   private Dimension calcExtent()  {
      Enumeration figenum = figures();
      Dimension extent = new Dimension(0,0);
      while (figenum.hasMoreElements()) {
          Figure figure = (Figure)figenum.nextElement();
          Dimension figureDim = figure.size();
          extent.width += figureDim.width;
          extent.height = Math.max(extent.height,figureDim.height);
      }
      return extent;
   }

}
