package de.renew.gui;

import CH.ifa.draw.figures.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import de.renew.remote.*;
import de.renew.simulator.*;
import java.awt.*;
import java.rmi.RemoteException;
import java.util.*;


public class MultipleTokenFigure extends HorizontalCompositeFigure {

    //   final Object token;
    //   private boolean expanded=true;

   public static String getMultString(int mult, boolean isTested)
   {
     StringBuffer output = new StringBuffer();

     if (isTested) {
       if (mult>0) {
	 output.append(String.valueOf(mult));
       }
       output.append("(1)");
     } else if (mult>1) {
       output.append(String.valueOf(mult));
     }
     if (isTested || mult>1) {
       output.append("'");
     }

     return output.toString();
   }

	public MultipleTokenFigure(RenewMode mode, int mult, boolean isTested,
		double time, ObjectAccessor token, boolean expanded)
	{
		String multStr=getMultString(mult,isTested);
		if (multStr.length()>0)
			add(new TextFigure(multStr, true));

		try
		{
			Figure tokenFig = token.getFigureFromMode(mode, expanded);
			add(tokenFig);

			if (token.isInstanceOf(NetInstance.class))
			{
				addClickHandle(new NetInstanceHandle(tokenFig,null,token.asNetInstance()));
			}
		}
		catch (RemoteException e)
		{
			e.printStackTrace(System.err);
		}

		if (time!=0)
		{
			add(new TextFigure("@"+time, true));
		}

		layout();
	}

    /**
     * Finds a top level Figure. Use this call for hit detection that
     * should not descend into the figure's children.
     */
    public Figure findFigure(int x, int y) {
	return null; // don't show your inside!
    }

/*
   public boolean inspect(DrawingView view, boolean alternate) {
     // undo support can be implemented here
     // (currently disabled for instance drawings)
     if (alternate) {
       toggleExpanded();
       return true;
     } else {
        return super.inspect(view,alternate);
     }

   }

   public void toggleExpanded() {
      expanded=!expanded;
      layout();
   }
*/
}

