package de.renew.gui;

import de.renew.shadow.ShadowCompiler;
import de.renew.remote.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.util.Palette;
import java.awt.Panel;
import java.awt.MenuBar;
import java.io.Serializable;


public interface RenewMode extends Serializable
{
	public ShadowCompiler getCompiler();
	
	public void setDrawingLoader(CPNDrawingLoader loader);

	public CPNDrawingLoader getDrawingLoader();

	public CPNSimulation getSimulation();

	public CPNTextFigure newInscriptionFigure(InscribableFigure figure);
	
	public String getDefaultInscription(InscribableFigure figure);
	
	public Figure getTokenFigure(Object token, boolean expanded);
	
	public void createAdditionalTools(CPNApplication editor, Panel toolPanel, Palette palette);
	
	public void createAdditionalMenus(CPNApplication editor, MenuBar mb);
	
	public Tool createPlaceTool(DrawingEditor editor);
	
	public Tool createTransitionTool(DrawingEditor editor);
	
	public boolean wantClock();
	
	public boolean wantAux();
	
	public String getAuxFigureName();
	
	public String getAuxToolName();
}
