package de.renew.gui;

import CH.ifa.draw.framework.Tool;
import CH.ifa.draw.util.Palette;
import CH.ifa.draw.standard.ConnectionTool;
import de.renew.shadow.ShadowCompiler;
import de.renew.formalism.java.*;
import java.awt.*;

public class SequentialJavaMode extends JavaMode {
  public ShadowCompiler getCompiler() {
    return new JavaNetCompiler(true,true,true);
  }

  public CPNSimulation getSimulation() {
    if (fSimulation==null) {
      fSimulation=new CPNSimulation(getCompiler(),true,getDrawingLoader());
    }
    return fSimulation;
  }

  public void createAdditionalTools(CPNApplication editor, Panel toolPanel,
				    Palette palette) {
    Tool tool = new ConnectionTool(editor,
      InhibitorConnection.InhibitorArc);
    palette.add(editor.createToolButton(CPNApplication.CPNIMAGES+"INHIB",
      "InhibitorArc Tool", tool));

    tool = new ConnectionTool(editor,
      HollowDoubleArcConnection.HollowArc);
    palette.add(editor.createToolButton(CPNApplication.CPNIMAGES+"DHARC",
      "ClearArc Tool", tool));
  }

  public boolean wantClock() {
    return true;
  }
}
