package de.renew.gui;

import CH.ifa.draw.framework.UndoableCommand;
import CH.ifa.draw.framework.DrawingEditor;
import CH.ifa.draw.standard.AbstractFigure;

/**
 * Sets the currently selected figure as simulation icon
 * for the active drawing.
 *
 * <p></p>
 * SetIconFigureCommand.java
 * Created: Fri Feb 23  2001
 * (Code moved from CPNApplication)
 *
 * @author Frank Wienberg, Michael Duvigneau
 */

public class SetIconFigureCommand extends UndoableCommand {

  DrawingEditor editor;

  public SetIconFigureCommand (String name, DrawingEditor editor){
    super(name, editor);
    this.editor = editor;
  }

  /**
   * @return <code>true</code>, if exactly one figure is selected.
   **/
  public boolean isExecutable() {
    return (editor.drawing() instanceof CPNDrawing)
      && (editor.view().selectionCount()==1);
  }

  public boolean executeUndoable() {
    if (isExecutable()) {
      ((CPNDrawing)editor.drawing()) 
	.setIconFigure((AbstractFigure)
		       editor.view().selectionElements()
		       .nextFigure());
      return true;
    }
    return false;
  }
}
