/*
 * @(#)FSNetMode.java 5.1
 *
 */

package de.renew.gui.fs;

import CH.ifa.draw.framework.Figure;
import de.renew.formalism.fsnet.*;
import de.renew.shadow.ShadowCompiler;
import de.renew.gui.*;
import de.renew.remote.*;
import de.uni_hamburg.fs.*;

/**
 * The mode for *real* FSNets
 */
public class FSNetMode extends FSMode {

  public ShadowCompiler getCompiler() {
      return new XFSNetCompiler();
  }

  public Figure getTokenFigure(Object token, boolean expanded) {
      if (!(token instanceof FeatureStructure ||
	    token instanceof de.renew.simulator.NetInstance ||
	    token instanceof de.renew.unify.Aggregate ||
	    token instanceof de.renew.util.Value ||
	    token instanceof String)) {
	token=new FeatureStructure(JavaObject.getJavaType(token));
      }
      return super.getTokenFigure(token,expanded);
  }


  public CPNTextFigure newInscriptionFigure(InscribableFigure figure) {
    if (figure instanceof ConceptConnection ||
	figure instanceof FeatureConnection)
	return super.newInscriptionFigure(figure);
    return new FSFigure();
  }

    /** Get the default text for a new inscription child.
     */
    public String getDefaultInscription(InscribableFigure figure) {
	if (figure instanceof PlaceFigure ||
	    figure instanceof TransitionFigure)
	    return "[]";
	if (figure instanceof ArcConnection) {
	    return "#1[]";
	}
	return super.getDefaultInscription(figure);
    }

}

