/*
 * @(#)IsaArrowTip.java 5.1
 *
 */

package de.renew.gui.fs;

import java.awt.*;

import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.util.*;
import CH.ifa.draw.figures.*;

/**
 * An isa arrow tip line decoration.
 * @see PolyLineFigure
 * @see IsaConnection
 */
public class IsaArrowTip extends ArrowTip {

   public IsaArrowTip() {
        super(0.60,15,12,false);
   }

   /**
    * Draws the arrow tip in the direction specified by the given two
    * points.
    */
    public void draw(Graphics g, int x1, int y1, int x2, int y2,
      Color fillColor, Color lineColor)
    {
        // TBD: reuse the Polygon object
        Polygon p = outline(x1, y1, x2, y2);
        //g.setColor(Color.white);
	g.setColor(fillColor);
        g.fillPolygon(p.xpoints, p.ypoints, p.npoints);
        //g.setColor(Color.black);
	g.setColor(lineColor);
        g.drawPolygon(p.xpoints, p.ypoints, p.npoints);
    }

}

