/*
 * @(#)SetEFSNetSemanticsCommand.java 5.1
 *
 */

package de.renew.gui.fs;

import java.util.*;
import CH.ifa.draw.util.Command;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.application.DrawApplication;
import de.renew.formalism.efsnet.EFSNetCompiler;

/**
 * A command to switch the semantics in EFSNets between
 * "Value" and "Reference".
 */
public class SetEFSNetSemanticsCommand extends Command {

    protected DrawApplication fEditor;
    private boolean fValueSem;

   /**
    * Constructs a toggle grid command.
    * @param name the command name
    * @param editor the editor
    * @param grid the grid size. A grid size of 1,1 turns grid snapping off.
    */
    public SetEFSNetSemanticsCommand(String name, DrawingEditor editor,
				     boolean valueSem) {
        super(name);
        fEditor = (DrawApplication)editor;
        fValueSem = valueSem;
    }

    public void execute() {
	EFSNetCompiler.valueSem=fValueSem;
    }

}


