package de.renew.gui.fs;

import java.awt.*;
import java.util.Vector;
import CH.ifa.draw.figures.TextFigure;
import CH.ifa.draw.figures.PolyLineFigure;
import CH.ifa.draw.figures.LineConnection;
import CH.ifa.draw.standard.RelativeLocator;
import CH.ifa.draw.standard.ConnectionHandle;
import CH.ifa.draw.framework.Connector;
import CH.ifa.draw.contrib.OutlineFigure;
import CH.ifa.draw.contrib.ChopPolygonConnector;

public class UMLNoteFigure extends TextFigure
			   implements OutlineFigure {

  private static final LineConnection anchor
      =new LineConnection(null,null,PolyLineFigure.LINE_STYLE_DASHED);

  public UMLNoteFigure() {
    super();
    setFrameColor(Color.black);
    setFillColor(Color.white);
  }

  public Vector handles() {
    Vector handles = super.handles();
    handles.addElement(new ConnectionHandle(this,RelativeLocator.center(),
					    anchor));
    return handles;
  }

  public void drawBackground(Graphics g) {
    g.fillPolygon(outline());
  }

  public void drawFrame(Graphics g) {
    g.drawPolygon(outline(true));
  }

  public Rectangle displayBox() {
    Rectangle box=super.displayBox();
    return new Rectangle(box.x-5, box.y-5, box.width+10, box.height+10);
  }

  protected Dimension getLineDimension(int i) {
    Dimension dim=super.getLineDimension(i);
    if (i==0) {
	dim.width+=dogsEarSize();
    }
    return dim;
  }

  private int dogsEarSize() {
      return getMetrics(getLineFont(0)).getHeight()+5;
  }

  public Polygon outline() {
    return outline(false);
  }

  public Polygon outline(boolean line) {
    // should be cached...
    Rectangle box=displayBox();
    Polygon outline=new Polygon();
    int dogsEarSize=dogsEarSize();
    outline.addPoint(box.x,box.y);
    outline.addPoint(box.x+box.width-dogsEarSize,box.y);
    if (line) {
      outline.addPoint(box.x+box.width-dogsEarSize,box.y+dogsEarSize);
      outline.addPoint(box.x+box.width-dogsEarSize,box.y);
    }
    outline.addPoint(box.x+box.width,box.y+dogsEarSize);
    if (line) {
      outline.addPoint(box.x+box.width-dogsEarSize,box.y+dogsEarSize);
      outline.addPoint(box.x+box.width,box.y+dogsEarSize);
    }
    outline.addPoint(box.x+box.width,box.y+box.height);
    outline.addPoint(box.x,box.y+box.height);
    return outline;
  }

  /**
   * Checks if a point is inside the figure's displayBox.
   */
  public boolean containsPoint(int x, int y) {
    if (isVisible())
      return outline().contains(x,y);
    return false;
  }


  public Connector connectorAt(int x, int y) {
    return new ChopPolygonConnector(this);
  }

}
