package de.renew.gui.maria;

import java.io.StringReader;
import de.renew.shadow.*;

class MariaCompiler implements ShadowCompiler {
  public static MariaParser createParser(String inscr) {
    return new MariaParser(new StringReader(inscr));
  }

  public ShadowLookup compile(ShadowNetSystem netSystem)
    throws SyntaxException 
  {
    // Do not compile any nets. We do not want to simulate.
    return new ShadowLookup();
  }

  public ShadowLookup compileMore(ShadowNetSystem netSystem)
    throws SyntaxException 
  {
    // Do not compile any nets. We do not want to simulate.
    return new ShadowLookup();
  }

  public String[] getLintNames() {
    return new String[0];
  }

  public void lint(int lintNr, ShadowNetSystem netSystem,
		   ShadowNet selectedNet, ShadowNet lastSelectedNet)
    throws SyntaxException
  {
    throw new RuntimeException("Not implemented.");
  }
    
  public String checkDeclarationNode(String inscr, boolean special)
    throws SyntaxException
  {
    try {
      createParser(inscr).netinscr();
    }
    catch  (ParseException e) {
      throw new SyntaxException(e.toString(),null);
    }
    return null;
  }

  public String checkArcInscription(String inscr, boolean special,
				    ShadowNet shadowNet)
    throws SyntaxException
  {
    try {
      createParser(inscr).marking_list();
    }
    catch  (ParseException e) {
      throw new SyntaxException(e.toString(),null);
    }
    return null;
  }

  public String checkTransitionInscription(String inscr, boolean special,
					   ShadowNet shadowNet)
    throws SyntaxException
  {
    try {
      createParser(inscr).transinscr();
    }
    catch  (ParseException e) {
      throw new SyntaxException(e.toString(),null);
    }
    return null;
  }

  public String checkPlaceInscription(String inscr, boolean special,
				      ShadowNet shadowNet)
    throws SyntaxException
  {
    try {
      if (special) {
	createParser(inscr).typeorcapacity();
      } else {
	createParser(inscr).placeinscr();
      }
    }
    catch  (ParseException e) {
      throw new SyntaxException(e.toString(),null);
    }
    return null;
  } 
}
