package de.renew.gui.xml;

import de.renew.shadow.*;

public abstract class InscriptionTypeSource {
  private static ShadowNet nullNet=new ShadowNet(null,new ShadowNetSystem());

  public InscriptionTypeSource() {}

  public String getType(String text, boolean special) {
    String type=null;
    try {
      // Try to determine the inscription
      // type in an empty shadow net.
      // This should return the same type,
      // but it runs faster and does not need
      // access to the declaration node.
      type=calculateType(text,special,nullNet);
    }
    catch (Exception e) {
      // No inscription type can be determined.
      return null;
    }
    return type;
  }

  public abstract String calculateType(String text, boolean special,
				       ShadowNet net) throws Exception;
}
