/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package de.renew.remote;

import de.renew.simulator.NetElementID;
import de.renew.simulator.Place;
import java.rmi.*;
import java.rmi.server.*;


/**
 * This class implements the <code>PlaceAccessor</code> interface
 * and nothing more.
 * <p>
 * </p>
 * PlaceAccessorImpl.java
 * Created: Fri Jul 14  2000
 * @author Michael Duvigneau
 */

public class PlaceAccessorImpl extends ObjectAccessorImpl implements PlaceAccessor
{
	/**
	 * Creates a new place accessor for the given place.
	 *
	 * @param place the place to access
	 * @exception java.rmi.RemoteException if an RMI failure occured.
	 */
	public PlaceAccessorImpl(Place place) throws RemoteException
	{
		super(place);
	}

	/* This method is specified by the PlaceAccessor interface. */
	/**
	 * Method documentation.
	 * @return
	 * @throws RemoteException
	 */
	public NetElementID getID() throws RemoteException
	{
		return ((Place) object).getID();
	}

	/**
	 * Returns the place, if the caller knows that
	 * this is the local representation. This is required for setting breakpoints.
	 * @return The place.
	 */
	public Place getPlace()
	{
		return ((Place) object);
	}
}
