package de.renew.remote;

import java.rmi.*;


/**
 * Use this class to access net instances and
 * other simulation elements remotely.
 */
public interface Server extends Remote
{
	/**
	 * The name of the default server.
	 */
	public static final String DEFAULT_SERVER_NAME = "default";

	/**
	 * Returns the current simulator of this server as an accessor.
	 * @return The simulator as an accessor.
	 * @exception RemoteException An RMI problem occurred.
	 */
	public SimulatorAccessor getSimulator()
		throws RemoteException;
}
