/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package de.renew.remote;

import de.renew.simulator.NetElementID;
import de.renew.simulator.Transition;
import java.rmi.*;
import java.rmi.server.*;


/**
 * This class implements the <code>TransitionAccessor</code> interface
 * and nothing more.
 * <p>
 * </p>
 * TransitionAccessorImpl.java
 * Created: Sun Jul 16  2000
 * @author Michael Duvigneau
 */

public class TransitionAccessorImpl extends ObjectAccessorImpl implements TransitionAccessor
{
	/**
	 * Creates a new transition accessor for the given transition.
	 *
	 * @param transition the transition to access
	 * @exception java.rmi.RemoteException if an RMI failure occured.
	 */
	public TransitionAccessorImpl(Transition transition) throws RemoteException
	{
		super(transition);
	}

	/* This method is specified by the TransitionAccessor interface. */
	/**
	 * Method documentation.
	 * @return
	 * @throws RemoteException
	 */
	public NetElementID getID() throws RemoteException
	{
		return ((Transition) object).getID();
	}

	/**
	 * Returns the transition, if the caller knows that
	 * this is the local representation. This is required for setting breakpoints.
	 * @return The transition.
	 */
	public Transition getTransition()
	{
		return ((Transition) object);
	}
}
