package de.renew.simulator;

import collections.*;
import de.renew.unify.*;
import java.util.Enumeration;

public class AbortFinder implements Finder {
  private boolean abortRequested=false;
  private Finder finder;
  private CollectionEnumeration executables=null;

  public AbortFinder(Finder finder) {
    this.finder=finder;
  }
  
  public void found(Searcher searcher) {
    finder.found(searcher);
  }

  public void abortSearch() {
    abortRequested=true;
  }

  public boolean isCompleted() {
    return abortRequested || finder.isCompleted();
  }
}
