package de.renew.simulator;

import collections.*;
import de.renew.unify.*;

class ArcAssignBinder extends AssignBinder {
  private PlaceInstance placeInstance;
  private boolean wantTest;
  
  public ArcAssignBinder(Variable variable, PlaceInstance placeInstance,
			 boolean wantTest)
  {
    super(variable,false);
    this.placeInstance=placeInstance;
    this.wantTest=wantTest;
  }

  public final void lock() {
    placeInstance.lock.lock();
  }

  public final void unlock() {
    placeInstance.lock.unlock();
  }
  
  public CollectionEnumeration getCandidates(Object pattern) {
    CollectionEnumeration result;
    if (wantTest) {
      result=placeInstance.getDistinctTestableTokens(pattern);
    } else {
      result=placeInstance.getDistinctTokens(pattern);
    }
    
    return result;
  }
  
  public TriggerableCollection getTriggerables() {
    return placeInstance.triggerables();
  }
}
