/**
 * ConsoleTracerFactory.java
 *
 *
 * Created: Thu Mar  9 10:59:13 2000
 *
 * @author Frank Wienberg
 * @version 1.1
 */

package de.renew.simulator;

public class ConsoleTracerFactory implements TracerFactory {

  private final String constantPrefix;
  private final String constantSuffix;

  public ConsoleTracerFactory() {
      constantPrefix="";
      constantSuffix="";
  }

  public ConsoleTracerFactory(String constantPrefix) {
      this.constantPrefix="("+constantPrefix;
      this.constantSuffix=") ";
  }

  public Tracer getTracer(String initialMessage, String prefix) {
      return new ConsoleTracer(initialMessage, constantPrefix + prefix + constantSuffix);
  }

}
