package de.renew.simulator;

import de.renew.expression.*;
import collections.*;
import de.renew.util.*;
import de.renew.unify.*;

class DownlinkOccurrence implements InscriptionOccurrence {
  DownlinkInscription downlinkInscription;
  VariableMapper mapper;

  DownlinkOccurrence(DownlinkInscription downlinkInscription,
    VariableMapper mapper)
  {
    this.downlinkInscription=downlinkInscription;
    this.mapper=mapper;
  }
  
  public CollectionEnumeration makeBinders(Searcher searcher)
    throws Impossible
  {
    Variable callee=new Variable(
      downlinkInscription.callee.startEvaluation(mapper,
	searcher.recorder,searcher.calcChecker),
	searcher.recorder);
    Variable params=new Variable(
      downlinkInscription.params.startEvaluation(mapper,
	searcher.recorder,searcher.calcChecker),
	searcher.recorder);
    
    return new SingletonEnumeration(
      new ChannelBinder(callee,downlinkInscription.name,params,
	downlinkInscription.isOptional));
  }

  public CollectionEnumeration makeExecutables(Copier copier,
    VariableMapper copiedMapper)
  {
    // A downlink does not cause any explicit action
    // during execution.
    return new EmptyEnumeration();
  }
}
