package de.renew.simulator;

import de.renew.unify.Impossible;
import de.renew.expression.VariableMapper;
import de.renew.expression.Expression;
import java.io.Serializable;
import collections.CollectionEnumeration;
import de.renew.util.SingletonEnumeration;

/**
 * This is a special inscriptions that tries to unify
 * a number of different values with the result of an expression.
 *
 * @author Olaf Kummer
 **/
public abstract class EnumeratorInscription implements TransitionInscription {
  Expression expr;
  boolean checkBound;

  public EnumeratorInscription(Expression expr, boolean checkBound) {
    this.expr=expr;
    this.checkBound=checkBound;
  }

  public CollectionEnumeration makeOccurrences(VariableMapper mapper,
    NetInstance netInstance, Searcher searcher) throws Impossible
  {
    return new SingletonEnumeration(new EnumeratorOccurrence(this,mapper));
  } 

  public abstract CollectionEnumeration getCandidates(Object pattern);
}
