package de.renew.simulator;

import de.renew.expression.*;
import collections.CollectionEnumeration;
import de.renew.unify.*;
import de.renew.util.SingletonEnumeration;
import de.renew.util.EmptyEnumeration;

class EnumeratorOccurrence implements InscriptionOccurrence {
  private EnumeratorInscription enumerator;
  private VariableMapper mapper;

  EnumeratorOccurrence(EnumeratorInscription enumerator,
		       VariableMapper mapper)
  {
    this.enumerator=enumerator;
    this.mapper=mapper;
  }

  public CollectionEnumeration makeBinders(Searcher searcher)
    throws Impossible 
  {
    Variable var=new Variable(
      enumerator.expr.startEvaluation(mapper,searcher.recorder,
        searcher.calcChecker),
      searcher.recorder);
    
    return new SingletonEnumeration(new EnumeratorBinder(enumerator,var));
  }

  public CollectionEnumeration makeExecutables(Copier copier,
    VariableMapper copiedMapper)
  {
    return EmptyEnumeration.INSTANCE;
  }
}
