package de.renew.simulator;

import collections.*;

public class EventHelper {
  public static Place getNamedPlace(Net net, String name) {
    CollectionEnumeration enum=net.places();
    while (enum.hasMoreElements()) {
      Place place=(Place)enum.nextElement();
      // Using the toString() method is ugly.
      // Maybe create a getName() method?
      if (name.equals(place.toString())) {
				return place;
      }
    }
    return null;
  }

  public static void deposit(NetInstance ni, String name, Object token) {
    Place place=getNamedPlace(ni.getNet(),name);
    if (place==null) {
      throw new RuntimeException("No such place.");
    }
    PlaceInstance pi=ni.getInstance(place);
    pi.lock.lock();
    pi.insertToken(token,0);
    pi.lock.unlock();
  }
}
