package de.renew.simulator;

class InitialBindingRunnable implements Runnable {
  private NetInstance primaryInstance;
  private ExecuteFinder finder;
  private Tracer tracer;

  InitialBindingRunnable(NetInstance primaryInstance,
			 ExecuteFinder finder,
			 Tracer tracer)
  {
    this.primaryInstance=primaryInstance;
    this.finder=finder;
    this.tracer=tracer;
  }

  public void run() {
    // Confirm the permanent activation for the
    // fully spontaneous transitions of this net. The
    // confirmation is only done if the synchronisation succeeds,
    // because conceptionally, the net instance is not created
    // otherwise. But the confirmation must be done before the
    // initial transition is executed, because another binding
    // is sought immediately.
    primaryInstance.createConfirmation(tracer);

    // Execute the initial transition. Its binding
    // is recorded in the finder.
    finder.execute(tracer,false);
  }
}
