package de.renew.simulator;

import collections.*;
import java.util.*;
import de.renew.unify.*;

public class InspectableBinding {
  private Binding binding;
  private Vector occurrences;
  private Vector mappers;
  private String description;

  public InspectableBinding(Searcher searcher) {
    binding=new Binding(searcher);
    occurrences=new Vector();
    mappers=new Vector();

    StringBuffer descr=new StringBuffer();

    CollectionEnumeration enum=searcher.getOccurrences();
    while (enum.hasMoreElements()) {
      TransitionOccurrence occurrence=
	(TransitionOccurrence)enum.nextElement();
      descr.append(occurrence.toString());

      occurrences.addElement(occurrence);
      mappers.addElement(
        occurrence.getMapper().makeCopy(new Copier()));

      if (enum.hasMoreElements()) {
	descr.append(", ");
      }
    }
  
    description=descr.toString();
  }

  public String getDescription() {
    return description;
  }

  public Enumeration getOccurrences() {
      return occurrences.elements();
  }

  public Enumeration getMappers() {
      return mappers.elements();
  }

  public boolean execute(final Tracer tracer, final boolean asynchronous) {
      return binding.execute(tracer,asynchronous);
  }
}
