package de.renew.simulator;

import de.renew.expression.*;
import collections.*;
import de.renew.unify.*;
import de.renew.util.Value;
import de.renew.util.EmptyEnumeration;


public class ManualInscription implements TransitionInscription
{
	private static ManualInscription singleton;

	private Expression expression;

	private ManualInscription()
	{
		expression = new ConstantExpression(Boolean.class, Boolean.TRUE);
	}

	public static synchronized ManualInscription getInstance()
	{
		if (singleton == null)
		{
			singleton = new ManualInscription();
		}
		
		return singleton;
	}

	public CollectionEnumeration makeOccurrences(VariableMapper mapper,
		NetInstance netInstance, Searcher searcher)
		throws Impossible
	{
		return EmptyEnumeration.INSTANCE;
	}
}
