package de.renew.simulator;

import collections.*;
import de.renew.util.*;
import de.renew.unify.Unify;
import de.renew.expression.Expression;

public class SimpleEnumeratorInscription extends EnumeratorInscription {
  private Collection collection;

  public SimpleEnumeratorInscription(Expression expr, Collection collection,
				     boolean checkBound)
  {
    super(expr,checkBound);
    this.collection=collection;
  }

  public CollectionEnumeration getCandidates(Object pattern) {
    if (Unify.isBound(pattern)) {
      if (collection.includes(pattern)) {
	return new SingletonEnumeration(pattern);
      } else {
	return EmptyEnumeration.INSTANCE;
      }
    } else {
      return collection.elements();
    }
  }
}
