package de.renew.simulator;

import collections.*;
import de.renew.unify.*;

class UntestArcExecutable implements LateExecutable {
  // Here we store the test arc executable, whose action
  // we are supposed to undo. Untesting arbitrary tokens at
  // arbitrary times is not required.
  TestArcExecutable tester;

  UntestArcExecutable(TestArcExecutable tester) {
    this.tester=tester;
  }

  public int phase() {
    return OUTPUT;
  }

  // We can untest a token quickly.
  public boolean isLong() {
    return false;
  }

  public void execute(Tracer tracer) {
    if (tester.trace) {
      tracer.trace("    Untesting "+tester.token+
	" in "+tester.placeInstance);
    }
    tester.placeInstance.lock.lock();
    tester.placeInstance.untestToken(tester.token);
    tester.placeInstance.lock.unlock();
  }
}
