package de.renew.unify;

import collections.*;
import java.io.Serializable;

public class ComponentBranch implements Serializable {
  int size=0;
  ArityBranch[] indexes;
  final UpdatableSet all=new HashedSet();

  ComponentBranch(int arity) {
    indexes=new ArityBranch[arity];
    for (int i=0;i<arity;i++) {
      indexes[i]=new ArityBranch();
    }
  }

  public CollectionEnumeration elements() {
    return all.elements();
  }

  void traverse(TupleIndexVisitor visitor, Object remainder) {
    for (int i=0;i<indexes.length;i++) {
      // If we reach this point, the current remainder must
      // be a non-empty aggregate.
      indexes[i].traverse(visitor,
	((Aggregate)remainder).references[i].value);
    }
    visitor.visitBranch(this);
  }
}
