package de.renew.unify;

import collections.*;
import de.renew.util.Null;
import java.io.Serializable;

public class TupleIndex implements Serializable {
	ArityBranch tree=new ArityBranch();
	UpdatableSet elements=new HashedSet();

	public TupleIndex() {}

	static Integer theHashCode(Object object) {
		return new Integer(Null.convert(object).hashCode());
	}

	public synchronized void insert(final Object element) {
		final Object elem=Null.convert(element);
		elements.include(elem);
		tree.traverse(new TupleIndexVisitor() {
			public void visitBranch(ComponentBranch branch) {
				branch.size++;
				branch.all.include(elem);
			}
			public boolean visitIndex(ArityBranch branch, Object remainder) {
				branch.hashCodeRelation.put(theHashCode(remainder),elem);
				return true;
			}
		},element);
	}

	public synchronized void remove(final Object element) {
		final Object elem=Null.convert(element);
		elements.exclude(elem);
		tree.traverse(new TupleIndexVisitor() {
			public void visitBranch(ComponentBranch branch) {
				branch.size--;
				branch.all.removeOneOf(elem);
			}
			public boolean visitIndex(ArityBranch branch, Object remainder) {
				branch.hashCodeRelation.remove(theHashCode(remainder),elem);
				return true;
			}
		},element);
	}

	public CollectionEnumeration getAllElements() {
		return elements.elements();
	}

	public CollectionEnumeration getPossibleMatches(Object pattern) {
		EstimateVisitor visitor=new EstimateVisitor();
		tree.traverse(visitor,pattern);
		visitor.possibleEnumeration(getAllElements());

		return Null.convertEnumeration(visitor.bestEnumeration);
	}

	public String toString() {
		StringBuffer buffer = new StringBuffer();
		buffer.append("de.renew.unify.TupleIndex(");
		CollectionEnumeration enum = getAllElements();
		while (enum.hasMoreElements()) {
			buffer.append(enum.nextElement());
			if (enum.hasMoreElements()) buffer.append(", ");
		}
		buffer.append(")");
		return buffer.toString();
	}
}
