package de.renew.util;

import collections.CollectionEnumeration;
import java.util.NoSuchElementException;

public final class RangeEnumeration implements CollectionEnumeration {
  private int next;
  private int last;
  private boolean more;

  public RangeEnumeration(int first, int last) {
    next=first;
    this.last=last;
    more=true;
  }

  public boolean hasMoreElements() {
    return more;
  }
  public Object nextElement() throws NoSuchElementException {
    if (more) {
      Object result=new Value(new Integer(next));
      more=(next!=last);
      next++;
      return result;
    } else {
      throw new NoSuchElementException();
    }
  }
  public boolean corrupted() {
    return false;
  }
  public int numberOfRemainingElements() {
    return last+1-next;
  }
}
