package de.uni_hamburg.fs;

import java.lang.reflect.*;
import de.renew.util.Types;
import de.renew.util.Value;

class IndexFeature extends JavaFeature {
    private Method getCount,get,add;
    private Class returnType;

    IndexFeature(Method getCount, Method get, Method add) {
	this.getCount=getCount;
	this.get=get;
	this.add=add;
	returnType=Array.newInstance(get.getReturnType(),0).getClass();
    }

    Class getJavaClass() {
	return returnType;
    }

    Object getObjectValue(Object javaObject) {
      Throwable e=null;
      try {
	int count=((Integer)getCount.invoke(javaObject,JavaConcept.NOPARAM))
	    .intValue();
	Object[] result=(Object[])Array.newInstance(get.getReturnType(),count);
	for (int i=0; i<count; ++i) {
	    result[i]=get.invoke(javaObject,new Object[]{new Integer(i)});
	}
	return result;
      } catch (IllegalAccessException e1) {
	e=e1;
	// should not happen
      } catch (IllegalArgumentException e2) {
	e=e2;
	// should not happen
      } catch (InvocationTargetException e3) {
	e=e3.getTargetException();
      }
      System.err.println("Could not get index values of Object "+javaObject+":");
      e.printStackTrace();
      //throw new RuntimeException("Exception during feature extraction:");
      return null;
    }

    boolean canSet() {
      return add!=null;
    }

    void setObjectValue(Object javaObject, Object value) {
	if (add==null) {
	    // no add method
	    String msg="Cannot set attribute of objects of "+javaObject.getClass().getName()+": No add method for\n"+get;
	    System.err.println(msg);
	    throw new RuntimeException(msg);
	}
	Throwable e=null;
	try {
	  Object[] valarray=(Object[])value;
	  for (int i=0; i<valarray.length; ++i) {
	    add.invoke(javaObject,new Object[]{valarray[i]});
	  }
	  return;
	} catch (IllegalAccessException e1) {
	    e=e1;
	    // should not happen
	} catch (IllegalArgumentException e2) {
	    e=e2;
	    // should not happen
	} catch (InvocationTargetException e3) {
	    e=e3.getTargetException();
	} catch (Throwable t) {
	    e=t;
	}
	e.printStackTrace();
	throw new RuntimeException("Exception during feature setting:");
    }

}
